/********************************************************************
	:	20111222<13:51:21>
	ļ:	PDSAlgorithm.h
	ԭʼ:	
	ļ:	ļṩ㷨ĺ
            еĺʹ,ݽ,һʹȫֱе
            ı˵һҪȷ,ѧйĺ,һҪд
	
	޸ļ¼:
	汾        ޸                        ޸
*********************************************************************/
#ifndef PDSALGORITHM_H
#define PDSALGORITHM_H

#include <afxtempl.h>

//߶
//  ཫڼεĹʹ,ÿһ¼ߵֵͷ
class CPDSSegment : public CObject
{
public:
  CList<CPoint,CPoint> m_listPoint;  //ʵʵ
  int m_iCurveIndex;                 //thisߵֵ
                                     //  :ڼεĹ,ñ¼thisȡһ(ȡΪlist)
  BOOL m_bDirection;                 //=TRUE ͬ, =FALSE ෴
                                     //  :ڼεĹ,ñ¼m_listPointlistǷͷβ˳ͬ,
                                     //    =FALSEʾm_listPointͷβķlistβͷķ

  int m_iIndex;  //this()еֵ,Ըʵָñĺ

  CPDSSegment(void);
  CPDSSegment(CList<CPoint,CPoint>& listPoint, int iCurveIndex, BOOL bDirection, int iIndex);
  CPDSSegment(CPDSSegment& rhs);
  CPDSSegment& operator=(CPDSSegment& rhs);
  BOOL operator==(CPDSSegment& rhs);
  BOOL operator!=(CPDSSegment& rhs);
  void Initial(void);
};
//typedef CList<CPDSSegment,CPDSSegment&> CPDSSegmentList;

class CPDSSegmentList : public CList<CPDSSegment,CPDSSegment&>
{
public:
  CPDSSegmentList& operator=(CPDSSegmentList& rhs);
  BOOL operator==(CPDSSegmentList& rhs);
  BOOL operator!=(CPDSSegmentList& rhs);
  CPDSSegment& operator[](int iIndex);
};

//Ķ
//ر˵:
//  ڸĶγɵɸ,һ
//:
//  alCurve       ,ʱҪ֤ÿ2,ǶλҪβͬ,ڵĵ겻ͬ
//  listSegment   []߶,˳򽫸߶еĵһ,ʱ(ĻϿ˳ʱ)
//                CPDSSegment::m_iCurveIndexʾԪalCurveеĵڼ,0ʼ
//                CPDSSegment::m_bDirection=TRUEʾalCurve[]ͬ
//                CPDSSegment::m_iIndexʹ
//ֵ:
//  =TRUE ɹ, =FALSE ʧ,listSegmentΪ
BOOL CalculatePolygonWithMaxArea(CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& alCurve, CPDSSegmentList& listSegment);

//и
//ر˵:
//  иģʱ,ڶĿݺύ,Ҫγɵҵ,ֱӽм䲿οռ,ȼӿٶӳ;
//  нǰ뾶Ǳһģиһģʱγɼļн;
//:
//  iDPMM      ȷֱ(һڲλΪ1/iDPMM)
//  alCurve    ,ʱҪ֤ÿ2,ǶλҪβͬ,ڵĵ겻ͬ
//  iRadius    нǰ뾶,=0ʾн
//  dMaxError  Բʱ
//  alCutting  [],еÿһǱиĹ켣
//ֵ:
//  alCutting.GetSize()
int CalculateCuttingRegion(int iDPMM, CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& alCurve, int iRadius, double dMaxError, CArray<CList<CPoint,CPoint>,CList<CPoint,CPoint> >& alCutting);

//listSegmentߵĽ,ѽ뵽
void DividePDSSegmentList(CPDSSegmentList& listSegment);

//ȡĶ(ĳ߶εͷβڸ,ô1)
int GetPointDegree(CPoint ptPoint, CPDSSegmentList& listSegment);

//Ƴ(ߵͷβĶΪ1,ôǹ,ҪƳ)
void RemoveIsolateCurve(CPDSSegmentList& listSegment);

//ȡĶ
//:
//  listSelectSegment  [][]ȫ,ὫlistBorderSegmentеĵƳ
//  listBorderSegment  []ܹγɱ߽ĵ
void GetMaxBorder(CPDSSegmentList& listSelectSegment, CPDSSegmentList& listBorderSegment);

//ȡӵĵ
//:
//  listSelectSegment   [][]ȫ,һĳӵlistConnectSegment,ӸƳ
//  ptPoint             ,ͷβڸõĵ
//  listConnectSegment  []ӵĵ
void GetConnectSegment(CPDSSegmentList& listSelectSegment, CPoint ptPoint, CPDSSegmentList& listConnectSegment);

//бһ
//:
//  listConnectSegment  [][]뵱ǰбߵβӵĵ,ʱ,ӵ,ͰƳ
//  listBorderSegment   [][]ʱΪ,Ҫʹβ߷,ʱһӵβ
void AddOneSegment(CPDSSegmentList& listConnectSegment, CPDSSegmentList& listBorderSegment);

//һ
//:
//  ptLB  ½ǵ(left-bottom),ϵ
//  listConnectSegment  [][]뵱ǰбߵβӵĵ,ʱ,ӵ,ͰƳ
//  listBorderSegment   []ʱһӵβ
void AddOneSegment(CPoint ptLB, CPDSSegmentList& listConnectSegment, CPDSSegmentList& listBorderSegment);

//ȡ޵
//:
//  ptCenter  ת
//  listPoint  
//  bAntiClockwise  =TRUE ʱת,ϵ
//ֵ:
//  ޵Ǹ
//˵:
//  Ҫʱת,ôҪѡߵǸ;֮,ҪѡұߵǸ
CPoint GetLimitPoint(CPoint ptCenter, CList<CPoint,CPoint>& listPoint, BOOL bAntiClockwise);

//ȡ½ǵ
//:
//  listSegment  
//ֵ:
//  ,½ǵ.λ:ϵ
//˵:
//  ˴½ǵָ:yֵСǸ,ĵж,ôѡxֵСһ
CPoint GetLeftBottomPoint(CPDSSegmentList& listSegment);

//Բнǵʵʵ
//:
//  iDPMM       ȷֱ(һڲλΪ1/iDPMM)
//  listPoint1  һ
//  listPoint2  ڶ,listPoint2.GetHead()==listPoint1.GetTail()
//  iRadius     Բǰ뾶,Ϊ0
//  dMaxError   Բ,Ϊ0
//  listArc     []Բʵʵ
//ֵ:
//  =TRUE ɹ,listArcЧ, =FALSE ʧ,listArcΪ
BOOL CalculateArcCorner(int iDPMM, CList<CPoint,CPoint>& listPoint1, CList<CPoint,CPoint>& listPoint2, int iRadius, double dMaxError, CList<CPoint,CPoint>& listArc);

//listSegmentߵĽ,ѽ뵽
void DividePDSSegmentList_New(CPDSSegmentList& listSegment);

//listSegmentеͬ
//ر˵:
//  еĳЩ겢,Ƿǳӽ,IsSamePoint()=true,ôӦðĵΪͬ
void ConnectPDSSegmentSamePoint(CPDSSegmentList& listSegment);

//Сڸֵĵ,ظõλ
//ر˵:
//  (1)20160507,syf,Ӹú
//  (2)úCalculateCuttingRegion
//:
//  ptPoint      
//  listSegment  
//  dMaxError    ֵ
//ֵ:
//  ֵ,0ʼ,Ϊ-1ʧ
int FindNearestPoint_WithDistance(CPoint ptPoint, CPDSSegmentList& listSegment, double dMaxError);

//ͬ߶
//ر˵:
//  (1)20160507,syf,Ӹú
//  (2)úCalculateCuttingRegion
//  (3)ʵlistSegment[].m_listPoint.GetCount()=2,ȫ߶,CalculateCuttingRegion㷨Ծ
//  (4)ڲҵĹ,Ե߶εķ,ֻҪǶ˵ͬΪͬ
//:
//  ptPoint1     ߶
//  ptPoint2     ߶յ
//  listSegment  
//ֵ:
//  ֵ,0ʼ,Ϊ-1ʧ
int FindSameSegment_2P(CPoint ptPoint1, CPoint ptPoint2, CPDSSegmentList& listSegment);

//߾
//ر˵:
//  (1)ݽṹ,Ҳ,V10汾к,һҪ޸,ѷа汾,м!!!!
//  (2)ֻҪlistCurve.GetCount() >= 2,true
//  (3)ʱ,ݺ궨F_MAX_TANGENT_ERRORȡ,һ궨屻޸,ļͻı
//:
//  iDPMM         ֱ
//  listCurve     ,2,ֱӷfalse;ͷβͬ,ôնδ
//  ptFrom        ,Ӹõ㿪ʼ;õ㲻,߷,ձ֤(ptFrom,ptTangency)߷
//  bTangentPrev  =true ָǰ,=false ̷ָ
//  dLength       ߳,Ϊ0,ʹֵ
//:
//  ptFixPoint  ,ptFromĵ,һ(δڵڲ)
//  ptTangent   е
//ֵ:
//  =true ɹ,=false ʧ
BOOL CalculateTangentPD(int iDPMM, CList<CPoint,CPoint>& listCurve, CPoint ptFrom, BOOL bTangentPrev, double dLength, CPoint& ptFixPoint, CPoint& ptTangent);

#endif  //PDSALGORITHM_H